.386

.MODEL FLAT,STDCALL

OPTION CASEMAP :NONE

Include	EzProcess.inc

;Include masm32.inc
;Include debug.inc
;IncludeLib masm32.lib
;IncludeLib debug.lib


.CODE

AboutDialogProc Proc hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
	.If uMsg == WM_INITDIALOG
	.ElseIf uMsg == WM_COMMAND
		.If WORD PTR [wParam] == 5
			Invoke EndDialog, hWnd, TRUE
		.EndIf
	.ElseIf uMsg == WM_CTLCOLORSTATIC || uMsg==WM_CTLCOLORDLG
		; wParam = hDC of control, lParam = hWnd of control
		Invoke SetTextColor, wParam, 00FF0000h
		Invoke SetBkMode, wParam, TRANSPARENT
		Invoke GetSysColorBrush,COLOR_WINDOW
		RET
	.Else
		MOV EAX,FALSE
		RET
	.EndIf
	
	MOV EAX,TRUE
	RET
AboutDialogProc EndP

ErrorMessage Proc
Local lpErrorMessage:DWORD
	CALL GetLastError
	LEA EDX,lpErrorMessage
	Invoke FormatMessage, FORMAT_MESSAGE_ALLOCATE_BUFFER or FORMAT_MESSAGE_FROM_SYSTEM, NULL, EAX, LANG_NEUTRAL,EDX,0,NULL
	Invoke MessageBox,0, lpErrorMessage,0, MB_OK
	Invoke LocalFree, lpErrorMessage
	RET
ErrorMessage EndP


DlgProc Proc Uses EBX hDlg:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
Local hProcessesList	:HWND
Local hThreadsList		:HWND
Local hModulesList		:HWND


Local lvc				:LV_COLUMN
Local ProcEntry32		:PROCESSENTRY32
Local ThreadEntry32		:THREADENTRY32
Local ModuleEntry32		:MODULEENTRY32

Local lvi				:LVITEM
Local Buffer[12]		:DWORD

	MOV	EAX,uMsg
	.If	EAX == WM_INITDIALOG
		Invoke GetDlgItem,hDlg,IDC_PROCESSESLIST
		MOV hProcessesList,EAX
		
		MOV lvc.imask, LVCF_WIDTH OR LVCF_TEXT OR LVCF_FMT
		MOV lvc.fmt,LVCFMT_LEFT
		MOV lvc.pszText,Offset szProcessName
		MOV lvc.lx, 255
		
		Invoke SendMessage, hProcessesList, LVM_INSERTCOLUMN, 0, ADDR lvc
		
		MOV lvc.pszText,Offset szProcessID
		MOV lvc.fmt,LVCFMT_CENTER
		MOV lvc.lx, 100
		Invoke SendMessage, hProcessesList, LVM_INSERTCOLUMN, 1, ADDR lvc
		
		MOV lvc.pszText,Offset szParentProcessID
		MOV lvc.lx, 100
		Invoke SendMessage, hProcessesList, LVM_INSERTCOLUMN, 2, ADDR lvc
		
		MOV lvc.pszText,Offset szPriority
		MOV lvc.lx, 60
		Invoke SendMessage, hProcessesList, LVM_INSERTCOLUMN, 3, ADDR lvc
		
		MOV lvc.pszText,Offset szNumberOfThreads
		Invoke SendMessage, hProcessesList, LVM_INSERTCOLUMN, 4, ADDR lvc
		
		Invoke SendMessage, hProcessesList, LVM_SETEXTENDEDLISTVIEWSTYLE, 0, LVS_EX_FULLROWSELECT OR LVS_EX_LABELTIP OR LVS_EX_GRIDLINES
		
		
		Invoke GetDlgItem,hDlg,IDC_THREADSLIST
		MOV hThreadsList,EAX
		
		MOV lvc.imask, LVCF_WIDTH OR LVCF_TEXT OR LVCF_FMT
		MOV lvc.fmt,LVCFMT_CENTER
		MOV lvc.pszText,Offset szThreadID
		MOV lvc.lx, 80
		
		Invoke SendMessage, hThreadsList, LVM_INSERTCOLUMN, 0, ADDR lvc
		
		MOV lvc.pszText,Offset szInitPriority
		Invoke SendMessage, hThreadsList, LVM_INSERTCOLUMN, 1, ADDR lvc
		
		
		Invoke SendMessage, hThreadsList, LVM_SETEXTENDEDLISTVIEWSTYLE, 0, LVS_EX_FULLROWSELECT OR LVS_EX_LABELTIP OR LVS_EX_GRIDLINES
		
		
		Invoke GetDlgItem,hDlg,IDC_MODULESSLIST
		MOV hModulesList,EAX
		
		MOV lvc.imask, LVCF_WIDTH OR LVCF_TEXT OR LVCF_FMT
		MOV lvc.fmt,LVCFMT_LEFT
		MOV lvc.pszText,Offset szModuleName
		MOV lvc.lx, 100
		Invoke SendMessage, hModulesList, LVM_INSERTCOLUMN, 0, ADDR lvc
		
		MOV lvc.lx, 91
		MOV lvc.pszText,Offset szModuleBaseAddress
		Invoke SendMessage, hModulesList, LVM_INSERTCOLUMN, 1, ADDR lvc
		
		;MOV lvc.pszText,Offset szModuleSize
		;Invoke SendMessage, hModulesList, LVM_INSERTCOLUMN, 2, ADDR lvc
		
		Invoke SendMessage, hModulesList, LVM_SETEXTENDEDLISTVIEWSTYLE, 0, LVS_EX_FULLROWSELECT OR LVS_EX_LABELTIP OR LVS_EX_GRIDLINES
		
		Invoke SendMessage,hDlg,WM_COMMAND,IDM_REFRESHLIST,0
		
	.ElseIf EAX == WM_COMMAND
		MOV EAX,wParam
		SHR EAX,16
		;HIWORD wParam
		.If EAX == 0 || 1 ; 0 is a menu, 1 is an accelerator. Toolbar messages act like menu messages...
			;LOWORD wParam
			MOV EAX,wParam
			.If AX == IDM_REFRESHLIST
				Invoke GetDlgItem,hDlg,IDC_PROCESSESLIST
				MOV hProcessesList,EAX
				Invoke SendMessage,hProcessesList,WM_SETREDRAW,FALSE,0
				MOV lvi.cchTextMax,256
				MOV lvi.iItem,0
				
				
				Invoke SendMessage,hProcessesList,LVM_DELETEALLITEMS,0,0
				
				.If hSnapShot
					Invoke CloseHandle,hSnapShot
				.EndIf
				
				Invoke CreateToolhelp32Snapshot,TH32CS_SNAPPROCESS OR TH32CS_SNAPTHREAD,NULL
				MOV hSnapShot,EAX
				
				;Get first process
				MOV ProcEntry32.dwSize,SizeOf PROCESSENTRY32
				Invoke Process32First,hSnapShot,ADDR ProcEntry32
				@@:
				.If EAX
					MOV lvi.imask,LVIF_TEXT OR LVIF_PARAM
					MOV EAX,ProcEntry32.th32ProcessID
					MOV lvi.lParam,EAX
					MOV lvi.iSubItem, 0
					LEA ECX,ProcEntry32.szExeFile
					MOV lvi.pszText,ECX
					Invoke SendMessage,hProcessesList,LVM_INSERTITEM,0,ADDR lvi
					MOV lvi.iItem,EAX
					
					MOV lvi.imask,LVIF_TEXT
					MOV lvi.iSubItem,1
					Invoke wsprintf, ADDR Buffer, Offset szHexTemplate,ProcEntry32.th32ProcessID
					LEA ECX,Buffer
					MOV lvi.pszText,ECX
					MOV lvi.iSubItem, 1
					Invoke SendMessage,hProcessesList,LVM_SETITEM,0,ADDR lvi			
					
					MOV lvi.iSubItem,2
					Invoke wsprintf, ADDR Buffer, Offset szHexTemplate,ProcEntry32.th32ParentProcessID
					LEA ECX,Buffer
					MOV lvi.pszText,ECX
					Invoke SendMessage,hProcessesList,LVM_SETITEM,0,ADDR lvi
					
					MOV lvi.iSubItem,3
					Invoke wsprintf, ADDR Buffer, Offset szDecTemplate,ProcEntry32.pcPriClassBase
					LEA ECX,Buffer
					MOV lvi.pszText,ECX
					Invoke SendMessage,hProcessesList,LVM_SETITEM,0,ADDR lvi
					;If we want priority class as well, uncoment the following
					;Invoke OpenProcess,PROCESS_ALL_ACCESS, FALSE, ProcEntry32.th32ProcessID
					;.If EAX
					;	PUSH EAX
					;	Invoke GetPriorityClass,EAX
					;	PrintHex EAX
					;	POP EAX
					;	Invoke CloseHandle,EAX	;hProcess
					;.EndIf
					
					
					
					MOV lvi.iSubItem,4
					Invoke wsprintf, ADDR Buffer, Offset szDecTemplate,ProcEntry32.cntThreads
					LEA ECX,Buffer
					MOV lvi.pszText,ECX
					Invoke SendMessage,hProcessesList,LVM_SETITEM,0,ADDR lvi
					
					;Get Next process
					Invoke Process32Next,hSnapShot,ADDR ProcEntry32
					
					JMP @B
					
				.EndIf
				
				MOV lvi.iItem,0
				MOV lvi.iSubItem,0
				MOV lvi.imask,LVIF_STATE
				MOV lvi.stateMask,LVIS_SELECTED Or LVIS_FOCUSED
				MOV lvi.state,LVIS_SELECTED Or LVIS_FOCUSED
				Invoke SendMessage,hProcessesList,LVM_SETITEM,0,ADDR lvi
				
				Invoke SendMessage,hProcessesList,WM_SETREDRAW,TRUE,0		
				Invoke UpdateWindow,hProcessesList
				
				Invoke SetFocus,hProcessesList
			.ElseIf AX == IDM_KILLPROCESS
				Invoke SendDlgItemMessage,hDlg,IDC_PROCESSESLIST,LVM_GETNEXTITEM,-1,LVNI_ALL or LVNI_SELECTED
				.If EAX!=-1
					MOV lvi.iItem,EAX
					Invoke MessageBox,hDlg,Offset szSureTerminateProcess,Offset szAppName,MB_YESNO
					.If EAX ==IDYES
						MOV lvi.iSubItem,0
						MOV lvi.imask, LVIF_PARAM
						Invoke SendDlgItemMessage,hDlg,IDC_PROCESSESLIST,LVM_GETITEM,0,ADDR lvi
						;lvi.lParam is the process ID
						Invoke OpenProcess,PROCESS_TERMINATE, FALSE,lvi.lParam
						.If EAX
							MOV EBX,EAX	;hProcess
							Invoke TerminateProcess,EBX,0
							.If !EAX
								Invoke ErrorMessage
							.EndIf
							Invoke CloseHandle,EBX	;hProcess
						.Else
							Invoke ErrorMessage
						.EndIf
						
						;Refresh
						Invoke SendMessage,hDlg,WM_COMMAND,IDM_REFRESHLIST,0
					.EndIf
				.EndIf 
			.ElseIf AX == IDM_EXIT
				Invoke DestroyWindow,hDlg
			.ElseIf AX==IDM_HELPABOUT
				Invoke DialogBoxParam,hInstance,1008,hDlg,Offset AboutDialogProc,NULL
			.EndIf
		.EndIf
		
	.ElseIf EAX==WM_NOTIFY
		MOV EBX,lParam
		Invoke GetDlgItem,hDlg,IDC_PROCESSESLIST
		.If [EBX].NMHDR.hwndFrom==EAX
			.If [EBX].NMHDR.code ==LVN_ITEMCHANGED
				.If [EBX].NM_LISTVIEW.uNewState;==LVIS_FOCUSED ;i.e focus and selected
					PUSH EDI
					MOV EDI,[EBX].NM_LISTVIEW.lParam	;Remember: =Selected Process ID
					
					Invoke GetDlgItem,hDlg,IDC_THREADSLIST
					MOV hThreadsList,EAX
					Invoke SendMessage,hThreadsList,WM_SETREDRAW,FALSE,0
					MOV lvi.cchTextMax,256
					MOV lvi.iSubItem, 0
					MOV lvi.imask,LVIF_TEXT
					LEA ECX,Buffer
					MOV lvi.pszText,ECX
					MOV lvi.iItem,0
					
					Invoke SendMessage,hThreadsList,LVM_DELETEALLITEMS,0,0
					
					;Get first Thread
					MOV ThreadEntry32.dwSize,SizeOf THREADENTRY32
					Invoke Thread32First,hSnapShot,ADDR ThreadEntry32
					@@:
					.If EAX
						.If ThreadEntry32.th32OwnerProcessID==EDI
							MOV lvi.iSubItem, 0
							Invoke wsprintf, ADDR Buffer, Offset szHexTemplate,ThreadEntry32.th32ThreadID
							Invoke SendMessage,hThreadsList,LVM_INSERTITEM,0,ADDR lvi
							MOV lvi.iItem,EAX
							
							MOV lvi.iSubItem,1
							Invoke wsprintf, ADDR Buffer, Offset szDecTemplate,ThreadEntry32.tpBasePri
							Invoke SendMessage,hThreadsList,LVM_SETITEM,0,ADDR lvi			
						.EndIf
						
						;Get Next Thread
						Invoke Thread32Next,hSnapShot,ADDR ThreadEntry32
						
						JMP @B
						
					.EndIf
					
					Invoke SendMessage,hThreadsList,WM_SETREDRAW,TRUE,0		
					Invoke UpdateWindow,hThreadsList
					
					
					Invoke GetDlgItem,hDlg,IDC_MODULESSLIST
					MOV hModulesList,EAX
					Invoke SendMessage,hModulesList,WM_SETREDRAW,FALSE,0
					MOV lvi.cchTextMax,256
					MOV lvi.iSubItem, 0
					MOV lvi.imask,LVIF_TEXT
					MOV lvi.iItem,0
					
					Invoke SendMessage,hModulesList,LVM_DELETEALLITEMS,0,0
					
					;We need a different snapshot since we want to sepcify the Process ID!
					Invoke CreateToolhelp32Snapshot,TH32CS_SNAPMODULE,EDI
					MOV EBX,EAX
					
					;Get first Module
					MOV ModuleEntry32.dwSize,SizeOf MODULEENTRY32
					Invoke Module32First,EBX,ADDR ModuleEntry32
					@@:
					.If EAX
						MOV lvi.iSubItem, 0
						LEA ECX,ModuleEntry32.szModule
						MOV lvi.pszText,ECX
						Invoke SendMessage,hModulesList,LVM_INSERTITEM,0,ADDR lvi
						MOV lvi.iItem,EAX
						
						MOV lvi.iSubItem,1
						Invoke wsprintf, ADDR Buffer, Offset szHexTemplate,ModuleEntry32.modBaseAddr
						LEA ECX,Buffer
						MOV lvi.pszText,ECX
						Invoke SendMessage,hModulesList,LVM_SETITEM,0,ADDR lvi
						
						;Wrong Value reported!!!!!!!!!!!
						;MOV lvi.iSubItem,2
						;Invoke wsprintf, ADDR Buffer, Offset szDecTemplate,ModuleEntry32.modBaseSize
						;LEA ECX,Buffer
						;MOV lvi.pszText,ECX
						;Invoke SendMessage,hModulesList,LVM_SETITEM,0,ADDR lvi
						
						;Get Next Module
						Invoke Module32Next,EBX,ADDR ModuleEntry32
						
						JMP @B
						
					.EndIf
					
					Invoke CloseHandle,EBX
					
					Invoke SendMessage,hModulesList,WM_SETREDRAW,TRUE,0		
					Invoke UpdateWindow,hModulesList
					
					POP EDI
					
				.EndIf
			.EndIf
		.EndIf
		
	.ElseIf EAX==WM_DESTROY
		Invoke CloseHandle,hSnapShot
		Invoke PostQuitMessage,NULL
	.Else
		Invoke DefWindowProc,hDlg,uMsg,wParam,lParam
		RET
	.EndIf
	XOR EAX,EAX
	RET
DlgProc EndP

StartUpProc Proc
Local wc		:WNDCLASSEX
Local msg		:MSG
Local hWnd		:HWND
Local hAccel	:HACCEL

	MOV wc.cbSize,SizeOf WNDCLASSEX
	MOV wc.style,NULL
	MOV wc.lpfnWndProc,Offset DlgProc
	MOV wc.cbClsExtra,NULL
	MOV wc.cbWndExtra,DLGWINDOWEXTRA
	PUSH hInstance
	POP wc.hInstance
	MOV wc.hbrBackground,COLOR_BTNFACE+1
	MOV wc.lpszMenuName,1000
	MOV wc.lpszClassName,Offset szDlgClass
	Invoke LoadIcon,hInstance,200
	MOV wc.hIcon,EAX
	MOV wc.hIconSm,EAX
	Invoke LoadCursor,NULL,IDC_ARROW
	MOV wc.hCursor,EAX
	Invoke RegisterClassEx,ADDR wc
	
	Invoke LoadAccelerators,hInstance,1
	MOV hAccel,EAX
	
	Invoke CreateDialogParam,hInstance,IDD_MAIN,NULL,Offset DlgProc,NULL
	MOV hWnd,EAX
	Invoke ShowWindow,hWnd,SW_SHOWDEFAULT
	Invoke UpdateWindow,hWnd
	
	.While TRUE
		Invoke GetMessage,ADDR msg,NULL,0,0
		.Break .If !EAX
		Invoke TranslateAccelerator,hWnd,hAccel,ADDR msg
		.If !EAX
			Invoke TranslateMessage,ADDR msg
			Invoke DispatchMessage,ADDR msg
		.EndIf
	.EndW
	MOV EAX,msg.wParam
	RET

StartUpProc EndP

Start:
	Invoke GetModuleHandle,NULL
	MOV hInstance, EAX
	Invoke InitCommonControls
	Invoke StartUpProc
	Invoke ExitProcess,EAX
End Start